<?
	/****************************************************************************
	* Software distributed under the License is distributed on an "AS IS" 		*
	* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 	*
	* License for a specific language governing rights and limitations under	*
	* the License. 																*
	* 																			*
	*	The Original Code is - InTerra Blog Machine   				            *
	* 																			*
	*	The Initial Developer of the Original Code is 							*
	* 																			*
	* 			Kulikov Alexey <alex [at] essentialmind [dot] com>	 			*
	* 																			*
	* 				All Rights Reserved // www.inses.ru							*
	* 																			*
	* Read the full license in the license.rtf file distributed along with		*
	* this software package.													*
	*****************************************************************************/
	
	//disable cache
	$smarty->caching = false;
	
	if($_POST){
		$entryID = (int)$_GET['id'];
		
		//check if this post allows comments
		$entry = $db->getRow("SELECT content, comments FROM int_entry WHERE entryid = '".$entryID."'");
		if($entry['comments'] =='1'){
			
			if($_SESSION['admin'] and $_POST['replyto']){
				//get some libraries
				require("lib/wacko/classes/macroProcessor.class.php");
				$parser = &new macroProcessor();
		
				//this is an admin reply =) be cool =)
				$adminReply = true;
				$replyTo = $_POST['replyto'];
				$mail = BLOGMASTER;
				$sender = BLOGMASTER;
				$comment = $parser->process($_POST['comment']);
				$unprocessedComment = $_POST['comment'];
			}else{
				//include safeHTML parser
				require('lib/safehtml/classes/HTMLSax.php');
				require('lib/safehtml/classes/safehtml.php');

				//prepare contents
				$comment = strip_tags($_POST['comment'],"<a>,<i>,<b>");
				$sender = htmlspecialchars(trim($_POST['sender']));
				$mail = htmlspecialchars(trim($_POST['mail']));
				
				###################################
				//parse contents through safehtml
				$comment = stripslashes($comment);
				
				// Save all "<" symbols
				$comment = preg_replace("/<(?=[^a-zA-Z\/\!\?\%])/", "&lt;", $comment);
				
				// Opera6 bug workaround
				$comment = str_replace("\xC0\xBC", "&lt;", $comment);
				
				// Instantiate the handler  parser
				$handler=& new safehtml();
				$parser=& new XML_HTMLSax();
				
				// Register the handler with the parser
				$parser->set_object($handler);
				
				// Set the handlers
				$parser->set_element_handler('openHandler','closeHandler');
				$parser->set_data_handler('dataHandler');
				$parser->set_escape_handler('escapeHandler');
				$parser->parse($comment);
				$comment = $handler->getXHTML();
				###################################
				
				
				//set cookies =)
				setcookie("sender",$sender,time()+24*60*60*365,"/");
				setcookie("senderMail",$mail,time()+24*60*60*365,"/");
				
				//errors =)
				if(empty($sender)){
					$sender = "anonymous @ " . $_SERVER['REMOTE_ADDR'];	
				}
				
				//fix some inputs
				$comment = ereg_replace("[\r\n|\r]","\n",trim($comment));
				$comment = ereg_replace("[\r\n|\n|\r]{3,}","\n\n",$comment);
				$comment = "<p>".nl2br($comment)."</p>";
				
				$adminReply = false;
			}
			
			//there needs to be some kind of comment, right?
			if(!empty($_POST['comment'])){
				if(eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$",$mail)){
					$notify = 1;
				}else{
					$notify = 0;	
				}
				
				//we are cool, process database query
				$db->query("LOCK TABLE int_comment WRITE");
				
				//admin replies are a bit different
				if($adminReply){
					//first need to figure out where to stick this thing in =)
					if(!$sortOrder = (int)$db->getOne("SELECT sortorder + 1 FROM int_comment WHERE parent = '".$replyTo."' ORDER BY sortorder DESC LIMIT 1")){
						$sortOrder = (int)$db->getOne("SELECT sortorder + 1 FROM int_comment WHERE commentid = '".$replyTo."'");			
					}
			
					$commentID = (int)$db->getOne("SELECT max(commentid)+1 FROM int_comment");
					$level = 1;
					$notify = 0;
					$res = $db->query("UPDATE int_comment SET sortorder = sortorder + 1 WHERE entryid = '".$entryID."' AND sortorder >= '$sortOrder'");
					$parent = $replyTo;
				}else{
					$sortOrder = (int)$db->getOne("SELECT max(sortorder)+1 FROM int_comment WHERE entryid = '".$entryID."'");
					if($sortOrder == 0){
						$sortOrder = 1;	
					}
					$level = 0;
					$commentID = (int)$db->getOne("SELECT max(commentid)+1 FROM int_comment");
					$parent = 'null';
				}
				
				$db->query("INSERT INTO int_comment SET
										commentid 	= '$commentID',
										content 	= '".$comment."',
										senderName	= '$sender',
										senderMail	= '$mail',
										entryid		= '$entryID',
										intime		= '".NOW."',
										notify		= '$notify',
										sortorder	= '$sortOrder',
										level		= '$level',
										parent		= $parent");
				
				$db->query("UNLOCK TABLES");
				$db->query("UPDATE int_entry SET commentcount = commentcount + 1 WHERE entryid = '".$entryID."'");
				
				//send e-mail to the BLOGMASTER
				if(!$adminReply){	//e-mail blog master of new comment
					$smarty->caching = false;
					$smarty->assign(array(
										"sender"		=> $sender,
										"senderMail"	=> $mail,
										"comment"		=> strip_tags($comment),
										"entry"			=> $entry['content'],
										"entryID"		=> $entryID,
										"commentID"		=> $commentID,
										"commentSO"		=> $sortOrder
										));
					$message = $smarty->preFetch("commentAdmin.txt");
					mail(BLOGMASTER,"New Comment!",$message,"FROM: ".MAILBOT."\nContent-type: text/plain; charset=".CHARSET);
					
				}else{	// notify comment master of blog master's reply
					$mailData = $db->getRow("SELECT senderName, senderMail, notify, content FROM int_comment WHERE commentid = '".$replyTo."'");
					
					if($mailData['notify'] == '1'){
						$smarty->caching = false;
						$smarty->assign(array(
											"sender"		=> $mailData['senderName'],
											"senderMail"	=> $mailData['senderMail'],
											"comment"		=> strip_tags($unprocessedComment),
											"entry"			=> strip_tags($mailData['content']),
											"entryID"		=> $entryID,
											"commentID"		=> $replyTo,
											"commentSO"		=> $sortOrder
											));
											
						$message = $smarty->preFetch("commentUser.txt");
						mail($mailData['senderMail'],"Reply to your Comment!",$message,"FROM: ".MAILBOT."\nContent-type: text/plain; charset=".CHARSET);	
					}
				}
				
				//kill cache if any
				$smarty->clear_cache(null,"entry|$entryID");
				$smarty->clear_cache(null,"______rootpage");
			}
		}
	}
	
	//this is a patch for opera and older versions of IE as they don't recognize internal redirects from other pages as page refresh commands
	if(stristr($_SERVER['HTTP_USER_AGENT'],"opera") or stristr($_SERVER['HTTP_USER_AGENT'],"MSIE 5.")){
		header("Location: ".SERVER_ROOT."entry/".$entryID."/");
	}else{
		header("Location: ".SERVER_ROOT."entry/".$entryID."/#".$commentID);
	}
	exit;
?>