<?
	/****************************************************************************
	* Software distributed under the License is distributed on an "AS IS" 		*
	* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 	*
	* License for a specific language governing rights and limitations under	*
	* the License. 																*
	* 																			*
	*	The Original Code is - InTerra Blog Machine   				            *
	* 																			*
	*	The Initial Developer of the Original Code is 							*
	* 																			*
	* 			Kulikov Alexey <alex [at] essentialmind [dot] com>	 			*
	* 																			*
	* 				All Rights Reserved // www.inses.ru							*
	*****************************************************************************/
	
	session_start();
	
	//security focus =)
	if(!$_SESSION['admin']){
		header("Location: " . SERVER_ROOT);
		exit;	
	}
	
	require("common/config.inc.php");
	require("lib/smarty/Smarty.class.php");
	require("common/mySmarty.class.php");

	/***
	 Now, initialize some mandatory resources, such as the template engine =)
	***/
	$smarty = new mySmarty();
	$smarty->caching = false;
	
	/***
	 Process POST request =)
	***/
	if($_POST){
		if($_FILES['myFile']['tmp_name']){
			//init library
			require("lib/uploader.class.php");			# image uploader
			
			//create uploader
			$myUpload = new uploader();		
			
			//check for existence of root path
			$uploadPath = "files" . DIRECTORY_SEPARATOR . $_SESSION['tempEntryID'] . DIRECTORY_SEPARATOR;
			$myUpload->preparePath($uploadPath);
			
			//prepare file name
			$_FILES['myFile']['name'] = str_replace(" ","",strtolower($_FILES['myFile']['name']));
			$_FILES['myFile']['name'] = str_replace("-","_",$_FILES['myFile']['name']);
			
			//check if file with this name exists
			if(!file_exists($uploadPath.$_FILES['myFile']['name'])){
				//check file to be uploaded is a jpeg, and create a thumbnail for it
				$myUpload->copyFile($_FILES['myFile']['tmp_name'],$uploadPath.$_FILES['myFile']['name']);
				
				//chmod
				@chmod($uploadPath.$_FILES['myFile']['name'], 0776);
			}
		}
		
		//redirect
		header("Location: ".SERVER_ROOT."filemanager/");
		exit;
	}
	
	if($_GET['action'] == 'delete'){
		@unlink("files" . DIRECTORY_SEPARATOR . (int)$_GET['entry'] . DIRECTORY_SEPARATOR . $_GET['file']);	
	}
	
	/***
	 Read File List =)
	***/
	$myFiles = array();
	
	if(is_dir("files" . DIRECTORY_SEPARATOR . $_SESSION['tempEntryID'] . DIRECTORY_SEPARATOR)){
		$myDir = dir("files" . DIRECTORY_SEPARATOR . $_SESSION['tempEntryID'] . DIRECTORY_SEPARATOR);
		while (false !== ($entry = $myDir->read())) {
			$data = array();
			if($entry != "." and $entry != ".."){
				$data['size'] = ceil(filesize("files" . DIRECTORY_SEPARATOR . $_SESSION['tempEntryID'] . DIRECTORY_SEPARATOR . $entry) / 1024);
				$data['name'] = $entry;
				$data['path'] = "files" . DIRECTORY_SEPARATOR . $_SESSION['tempEntryID'] . DIRECTORY_SEPARATOR . $entry;
				$myFiles[] = $data;
			}
		}
		$myDir->close();
		
		$smarty->assign("myFiles",$myFiles);
	}
	
	$smarty->assign("frameSize",count($myFiles));
	$smarty->display("addFiles.htm");
?>